package cn.com.infosec.asn1.x509;

import cn.com.infosec.asn1.ASN1InputStream;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERObjectIdentifier;
import cn.com.infosec.asn1.DERPrintableString;
import cn.com.infosec.util.Strings;

public abstract class X509NameEntryConverter {
   protected DERObject convertHexEncoded(String str, int off) {
      String var7;
      int str1;
      byte[] var3 = new byte[str1 = ((var7 = Strings.toLowerCase(str)).length() - off) / 2];

      for(int var4 = 0; var4 != str1; ++var4) {
         int var5;
         char var6;
         char var10000 = var6 = var7.charAt(var5 = var4 * 2 + off);
         char var9 = var7.charAt(var5 + 1);
         if (var10000 < 'a') {
            var3[var4] = (byte)(var6 - 48 << 4);
         } else {
            var3[var4] = (byte)(var6 - 97 + 10 << 4);
         }

         if (var9 < 'a') {
            var3[var4] |= (byte)(var9 - 48);
         } else {
            var3[var4] |= (byte)(var9 - 97 + 10);
         }
      }

      return (new ASN1InputStream(var3)).readObject();
   }

   protected boolean canBePrintable(String str) {
      return DERPrintableString.isPrintableString(str);
   }

   public abstract DERObject getConvertedValue(DERObjectIdentifier var1, String var2);
}
